package com.bpcl.lpg.core.jalo;

import java.util.Collections;
import java.util.HashMap;
import com.bpcl.lpg.core.constants.GeneratedBpcllpgcoreConstants;
import java.util.Date;
import de.hybris.platform.jalo.enumeration.EnumerationValue;
import java.util.Collection;
import de.hybris.platform.jalo.SessionContext;
import de.hybris.platform.jalo.Item;
import java.util.Map;
import de.hybris.platform.util.OneToManyHandler;
import de.hybris.platform.directpersistence.annotation.SLDSafe;
import com.bpcl.core.jalo.BPCLAccount;

@SLDSafe
public class LPGConnection extends BPCLAccount
{
    public static final String LPGID = "lpgId";
    public static final String CONSUMERSTATUS = "consumerStatus";
    public static final String CONSUMERID = "consumerID";
    public static final String CONSUMERNUMBER = "consumerNumber";
    public static final String CONNECTIONTYPE = "connectionType";
    public static final String DISTID = "distId";
    public static final String RSPPERCYCLE = "rspPerCycle";
    public static final String LASTUPDATEDRSPPERCYCLE = "lastUpdatedRspPerCycle";
    public static final String NETPAYPERCYLINDER = "netPayPerCylinder";
    public static final String LPGPAYMENTINFOS = "lpgpaymentInfos";
    public static final String CODREFILLS = "codRefills";
    protected static final OneToManyHandler<LpgPaymentInfo> LPGPAYMENTINFOSHANDLER;
    protected static final OneToManyHandler<CODRefills> CODREFILLSHANDLER;
    protected static final Map<String, Item.AttributeMode> DEFAULT_INITIAL_ATTRIBUTES;
    
    protected Map<String, Item.AttributeMode> getDefaultAttributeModes() {
        return LPGConnection.DEFAULT_INITIAL_ATTRIBUTES;
    }
    
    public Collection<CODRefills> getCodRefills(final SessionContext ctx) {
        return LPGConnection.CODREFILLSHANDLER.getValues(ctx, (Item)this);
    }
    
    public Collection<CODRefills> getCodRefills() {
        return this.getCodRefills(this.getSession().getSessionContext());
    }
    
    public void setCodRefills(final SessionContext ctx, final Collection<CODRefills> value) {
        LPGConnection.CODREFILLSHANDLER.setValues(ctx, (Item)this, (Collection)value);
    }
    
    public void setCodRefills(final Collection<CODRefills> value) {
        this.setCodRefills(this.getSession().getSessionContext(), value);
    }
    
    public void addToCodRefills(final SessionContext ctx, final CODRefills value) {
        LPGConnection.CODREFILLSHANDLER.addValue(ctx, (Item)this, (Item)value);
    }
    
    public void addToCodRefills(final CODRefills value) {
        this.addToCodRefills(this.getSession().getSessionContext(), value);
    }
    
    public void removeFromCodRefills(final SessionContext ctx, final CODRefills value) {
        LPGConnection.CODREFILLSHANDLER.removeValue(ctx, (Item)this, (Item)value);
    }
    
    public void removeFromCodRefills(final CODRefills value) {
        this.removeFromCodRefills(this.getSession().getSessionContext(), value);
    }
    
    public String getConnectionType(final SessionContext ctx) {
        return (String)this.getProperty(ctx, "connectionType".intern());
    }
    
    public String getConnectionType() {
        return this.getConnectionType(this.getSession().getSessionContext());
    }
    
    public void setConnectionType(final SessionContext ctx, final String value) {
        this.setProperty(ctx, "connectionType".intern(), (Object)value);
    }
    
    public void setConnectionType(final String value) {
        this.setConnectionType(this.getSession().getSessionContext(), value);
    }
    
    public String getConsumerID(final SessionContext ctx) {
        return (String)this.getProperty(ctx, "consumerID".intern());
    }
    
    public String getConsumerID() {
        return this.getConsumerID(this.getSession().getSessionContext());
    }
    
    public void setConsumerID(final SessionContext ctx, final String value) {
        this.setProperty(ctx, "consumerID".intern(), (Object)value);
    }
    
    public void setConsumerID(final String value) {
        this.setConsumerID(this.getSession().getSessionContext(), value);
    }
    
    public String getConsumerNumber(final SessionContext ctx) {
        return (String)this.getProperty(ctx, "consumerNumber".intern());
    }
    
    public String getConsumerNumber() {
        return this.getConsumerNumber(this.getSession().getSessionContext());
    }
    
    public void setConsumerNumber(final SessionContext ctx, final String value) {
        this.setProperty(ctx, "consumerNumber".intern(), (Object)value);
    }
    
    public void setConsumerNumber(final String value) {
        this.setConsumerNumber(this.getSession().getSessionContext(), value);
    }
    
    public EnumerationValue getConsumerStatus(final SessionContext ctx) {
        return (EnumerationValue)this.getProperty(ctx, "consumerStatus".intern());
    }
    
    public EnumerationValue getConsumerStatus() {
        return this.getConsumerStatus(this.getSession().getSessionContext());
    }
    
    public void setConsumerStatus(final SessionContext ctx, final EnumerationValue value) {
        this.setProperty(ctx, "consumerStatus".intern(), (Object)value);
    }
    
    public void setConsumerStatus(final EnumerationValue value) {
        this.setConsumerStatus(this.getSession().getSessionContext(), value);
    }
    
    public String getDistId(final SessionContext ctx) {
        return (String)this.getProperty(ctx, "distId".intern());
    }
    
    public String getDistId() {
        return this.getDistId(this.getSession().getSessionContext());
    }
    
    public void setDistId(final SessionContext ctx, final String value) {
        this.setProperty(ctx, "distId".intern(), (Object)value);
    }
    
    public void setDistId(final String value) {
        this.setDistId(this.getSession().getSessionContext(), value);
    }
    
    public Date getLastUpdatedRspPerCycle(final SessionContext ctx) {
        return (Date)this.getProperty(ctx, "lastUpdatedRspPerCycle".intern());
    }
    
    public Date getLastUpdatedRspPerCycle() {
        return this.getLastUpdatedRspPerCycle(this.getSession().getSessionContext());
    }
    
    public void setLastUpdatedRspPerCycle(final SessionContext ctx, final Date value) {
        this.setProperty(ctx, "lastUpdatedRspPerCycle".intern(), (Object)value);
    }
    
    public void setLastUpdatedRspPerCycle(final Date value) {
        this.setLastUpdatedRspPerCycle(this.getSession().getSessionContext(), value);
    }
    
    public String getLpgId(final SessionContext ctx) {
        return (String)this.getProperty(ctx, "lpgId".intern());
    }
    
    public String getLpgId() {
        return this.getLpgId(this.getSession().getSessionContext());
    }
    
    public void setLpgId(final SessionContext ctx, final String value) {
        this.setProperty(ctx, "lpgId".intern(), (Object)value);
    }
    
    public void setLpgId(final String value) {
        this.setLpgId(this.getSession().getSessionContext(), value);
    }
    
    public Collection<LpgPaymentInfo> getLpgpaymentInfos(final SessionContext ctx) {
        return LPGConnection.LPGPAYMENTINFOSHANDLER.getValues(ctx, (Item)this);
    }
    
    public Collection<LpgPaymentInfo> getLpgpaymentInfos() {
        return this.getLpgpaymentInfos(this.getSession().getSessionContext());
    }
    
    public void setLpgpaymentInfos(final SessionContext ctx, final Collection<LpgPaymentInfo> value) {
        LPGConnection.LPGPAYMENTINFOSHANDLER.setValues(ctx, (Item)this, (Collection)value);
    }
    
    public void setLpgpaymentInfos(final Collection<LpgPaymentInfo> value) {
        this.setLpgpaymentInfos(this.getSession().getSessionContext(), value);
    }
    
    public void addToLpgpaymentInfos(final SessionContext ctx, final LpgPaymentInfo value) {
        LPGConnection.LPGPAYMENTINFOSHANDLER.addValue(ctx, (Item)this, (Item)value);
    }
    
    public void addToLpgpaymentInfos(final LpgPaymentInfo value) {
        this.addToLpgpaymentInfos(this.getSession().getSessionContext(), value);
    }
    
    public void removeFromLpgpaymentInfos(final SessionContext ctx, final LpgPaymentInfo value) {
        LPGConnection.LPGPAYMENTINFOSHANDLER.removeValue(ctx, (Item)this, (Item)value);
    }
    
    public void removeFromLpgpaymentInfos(final LpgPaymentInfo value) {
        this.removeFromLpgpaymentInfos(this.getSession().getSessionContext(), value);
    }
    
    public Double getNetPayPerCylinder(final SessionContext ctx) {
        return (Double)this.getProperty(ctx, "netPayPerCylinder".intern());
    }
    
    public Double getNetPayPerCylinder() {
        return this.getNetPayPerCylinder(this.getSession().getSessionContext());
    }
    
    public double getNetPayPerCylinderAsPrimitive(final SessionContext ctx) {
        final Double value = this.getNetPayPerCylinder(ctx);
        return (value != null) ? value : 0.0;
    }
    
    public double getNetPayPerCylinderAsPrimitive() {
        return this.getNetPayPerCylinderAsPrimitive(this.getSession().getSessionContext());
    }
    
    public void setNetPayPerCylinder(final SessionContext ctx, final Double value) {
        this.setProperty(ctx, "netPayPerCylinder".intern(), (Object)value);
    }
    
    public void setNetPayPerCylinder(final Double value) {
        this.setNetPayPerCylinder(this.getSession().getSessionContext(), value);
    }
    
    public void setNetPayPerCylinder(final SessionContext ctx, final double value) {
        this.setNetPayPerCylinder(ctx, Double.valueOf(value));
    }
    
    public void setNetPayPerCylinder(final double value) {
        this.setNetPayPerCylinder(this.getSession().getSessionContext(), value);
    }
    
    public Double getRspPerCycle(final SessionContext ctx) {
        return (Double)this.getProperty(ctx, "rspPerCycle".intern());
    }
    
    public Double getRspPerCycle() {
        return this.getRspPerCycle(this.getSession().getSessionContext());
    }
    
    public double getRspPerCycleAsPrimitive(final SessionContext ctx) {
        final Double value = this.getRspPerCycle(ctx);
        return (value != null) ? value : 0.0;
    }
    
    public double getRspPerCycleAsPrimitive() {
        return this.getRspPerCycleAsPrimitive(this.getSession().getSessionContext());
    }
    
    public void setRspPerCycle(final SessionContext ctx, final Double value) {
        this.setProperty(ctx, "rspPerCycle".intern(), (Object)value);
    }
    
    public void setRspPerCycle(final Double value) {
        this.setRspPerCycle(this.getSession().getSessionContext(), value);
    }
    
    public void setRspPerCycle(final SessionContext ctx, final double value) {
        this.setRspPerCycle(ctx, Double.valueOf(value));
    }
    
    public void setRspPerCycle(final double value) {
        this.setRspPerCycle(this.getSession().getSessionContext(), value);
    }
    
    static {
        LPGPAYMENTINFOSHANDLER = new OneToManyHandler(GeneratedBpcllpgcoreConstants.TC.LPGPAYMENTINFO, true, "account", (String)null, false, true, 0);
        CODREFILLSHANDLER = new OneToManyHandler(GeneratedBpcllpgcoreConstants.TC.CODREFILLS, true, "account", (String)null, false, true, 0);
        final Map<String, Item.AttributeMode> tmp = new HashMap<String, Item.AttributeMode>(BPCLAccount.DEFAULT_INITIAL_ATTRIBUTES);
        tmp.put("lpgId", Item.AttributeMode.INITIAL);
        tmp.put("consumerStatus", Item.AttributeMode.INITIAL);
        tmp.put("consumerID", Item.AttributeMode.INITIAL);
        tmp.put("consumerNumber", Item.AttributeMode.INITIAL);
        tmp.put("connectionType", Item.AttributeMode.INITIAL);
        tmp.put("distId", Item.AttributeMode.INITIAL);
        tmp.put("rspPerCycle", Item.AttributeMode.INITIAL);
        tmp.put("lastUpdatedRspPerCycle", Item.AttributeMode.INITIAL);
        tmp.put("netPayPerCylinder", Item.AttributeMode.INITIAL);
        DEFAULT_INITIAL_ATTRIBUTES = Collections.unmodifiableMap((Map<? extends String, ? extends Item.AttributeMode>)tmp);
    }
}
